/***************************************************************
* file name			: user_config.c

* Description   : ʼɲüڴɳʼ
									

* Author    		: zc

* Version				: 0.1

* Date					: 2015.8.4

* History       
***************************************************************/
#define VALUE_INNER
#include "user_config.h"

/****************************************************************
* function   	: BSP_Init()

* Description : ϵͳʼ

* input			  : 

* output      : 
*****************************************************************/
void BSP_Init(void)
{
#if USE_RCC_PER
	RCC_UserConfig();
#endif
	
#if USE_LED_PER
	LED_UserConfig();
#endif
	
#if USE_KEY_PER
	KEY_UserConfig();
#endif

#if USE_USART1_PER
	 USART1_UserConfig();
#endif

#if USE_ADC1_PER	
	ADC1_UserConfig();
#if USE_ADC1_DMA_PER	
	ADC1_DMA_UserConfig();
#endif
#endif

#if USE_SPI_PER
	SPI1_GPIO_Config();
	SPI1_MODE_Config();
#endif
}

/****************************************************************
* function   	: RCC_UserConfig()

* Description : ϵͳʱӳʼ
                Ŀǰʱ50MHZ, ͨRCC_CFGR2ʵʱ72MHZ

* input			  : 

* output      : 
*****************************************************************/
#if USE_RCC_PER
static void RCC_UserConfig(void)
{
  ErrorStatus HSEStartUpStatus;
	RCC_DeInit();                                           
	
	/*ⲿپ*/
	RCC_HSEConfig(RCC_HSE_ON);                              
  HSEStartUpStatus = RCC_WaitForHSEStartUp();               
	if (HSEStartUpStatus == SUCCESS)                        
	{
		/*ʱģ*/
    RCC_HCLKConfig(RCC_SYSCLK_Div1);                      //AHBCLK = SYSCLK
	  RCC_PCLK2Config(RCC_HCLK_Div1);                       //APB2CLK2 = AHBCLK
		RCC_PCLK1Config(RCC_HCLK_Div2);                       //APB1CLK = AHBCLK/2
			  
		/*μ΢ֲ2.3.3˵ϵͳʱӹflashҪӵȴʱ*/
	  FLASH_SetLatency(FLASH_Latency_2);                    
		
		/*AHBƵϵ1ҪRCC_CFGRĴ74λ˵*/
	  FLASH_PrefetchBufferCmd(FLASH_PrefetchBuffer_Enable); 
		
		/*stm32ϵƵγòҪ72MHZ*/
		/*SYSTICK = (HSE_CLK/RCC_DIV)*RCC_PLL*/		
		RCC_PLLConfig(RCC_PLLSource_PREDIV2, RCC_PLLMul_4);   
		
		/*ʹPLLȴPLLɹΪϵͳʱӣȴɹ*/
	  RCC_PLLCmd(ENABLE);                                   
		while (RCC_GetFlagStatus(RCC_FLAG_PLLRDY) == RESET)   
		{
			//ӳʱֹ⿨ڲԭ
		}
		RCC_SYSCLKConfig(RCC_SYSCLKSource_PLLCLK);            
		while (RCC_GetSYSCLKSource() != 0x08)                 
		{
			//ͬ
		}
	}
}
#endif		

/****************************************************************
* function   	: LED_UserConfig()

* Description : LEDʼԭͼùܽ
								Ϊ˷ֲͷļض

* input			  : 

* output      : 
*****************************************************************/
#if USE_LED_PER
static void LED_UserConfig(void)
{
	GPIO_InitTypeDef GPIO_InitStructure;
	
	/*ʹʱӣԺע*/
	RCC_APB2PeriphClockCmd(RCC_LED_GPIO, ENABLE);   
	
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP;        
	GPIO_InitStructure.GPIO_Pin = GPIO_LED_ALL;             //ѡLEDĶ˿ڣɸʵҪ 
	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;       //趨GPIOƵ
	GPIO_Init(GPIO_LED, &GPIO_InitStructure); 
	
	GPIO_SetBits(GPIO_LED, GPIO_LED_ALL);
}
#endif

/****************************************************************
* function   	: Key_UserConfig()

* Description : keyʼԭͼùܽ

* input			  : 

* output      : 
*****************************************************************/
#if USE_KEY_PER
static void KEY_UserConfig(void)
{
	GPIO_InitTypeDef GPIO_InitStructure;
	RCC_APB2PeriphClockCmd(RCC_KEY_GPIO, ENABLE);        
	
	/*,Ĭϸߵƽ*/
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IPU;                   
	
	GPIO_InitStructure.GPIO_Pin = GPIO_KEY_Pin1 | GPIO_KEY_Pin3;          
	GPIO_Init(GPIO_KEY1_KEY3, &GPIO_InitStructure);    
	
	GPIO_InitStructure.GPIO_Pin = GPIO_KEY_Pin2;
	GPIO_Init(GPIO_KEY2, &GPIO_InitStructure);   
	
	GPIO_InitStructure.GPIO_Pin = GPIO_KEY_Pin4;   										 
	GPIO_Init(GPIO_KEY4, &GPIO_InitStructure);          								
}
#endif

/****************************************************************
* function   	: USART1_UserConfig()

* Description : USART1ʼ, ڴͨѶ, Ӧ˿PA9,PA10

* input			  : 

* output      : 
*****************************************************************/
#if USE_USART1_PER
static void USART1_UserConfig(void)
{
	USART_InitTypeDef USART_InitStructure;
	GPIO_InitTypeDef GPIO_InitStructure;
	USART_DeInit(USART1);
	
	RCC_APB2PeriphClockCmd(RCC_USART1, ENABLE);            
	
  GPIO_InitStructure.GPIO_Pin = USART1_TX_Pin;                
  GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF_PP;                 //ô1Ϊ
  GPIO_Init(USART1_TX,&GPIO_InitStructure);	
	
  GPIO_InitStructure.GPIO_Pin = USART1_RX_Pin;
  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IN_FLOATING;           //ô1Ϊ
  GPIO_Init(USART1_RX, &GPIO_InitStructure);
 
	USART_InitStructure.USART_BaudRate = 115200;                    //ôڲΪ115200
  USART_InitStructure.USART_WordLength = USART_WordLength_8b;     ///8λλ
  USART_InitStructure.USART_StopBits = USART_StopBits_1;          //ôֹͣλΪ1λ
  USART_InitStructure.USART_Parity = USART_Parity_No;             //żУ
  USART_InitStructure.USART_HardwareFlowControl = USART_HardwareFlowControl_None; //Ӳ
  USART_InitStructure.USART_Mode = USART_Mode_Rx | USART_Mode_Tx; //1
	
  USART_Init(USART1, &USART_InitStructure);
  USART_Cmd(USART1, ENABLE);	                                 		//ʹܴڣʼշ
}
#endif

/****************************************************************
* function   	: ADC_UserConfig()

* Description : ADC1صĳʼ,жȡܽPC0ͨ10

* input			  : 

* output      : 
*****************************************************************/
#if USE_ADC1_PER
void ADC1_UserConfig(void)
{
	GPIO_InitTypeDef GPIO_InitStructure;
	ADC_InitTypeDef ADC_InitStructure;
	ADC_DeInit(ADC1); 
	
	//ADCģʱAPB2ʱӻãڵʱӳ
	RCC_ADCCLKConfig(RCC_PCLK2_Div4);	
	//ʹADCӦGPIO,򼰸ùʱ	
	RCC_APB2PeriphClockCmd(RCC_ADC1, ENABLE);
	  
	//ʼADCģӦGPIO
  GPIO_InitStructure.GPIO_Pin = GPIO_ADC1_Pin;
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AIN;     
	GPIO_Init(GPIO_ADC1, &GPIO_InitStructure);
	
	ADC_InitStructure.ADC_Mode = ADC_Mode_Independent;    							//ADC1ADC2ڶģʽ
	ADC_InitStructure.ADC_ScanConvMode = ENABLE;          							//ɨʽ
	ADC_InitStructure.ADC_ContinuousConvMode = ENABLE;    							//תģʽ
	ADC_InitStructure.ADC_ExternalTrigConv = ADC_ExternalTrigConv_None; //תADC_Cmd
	ADC_InitStructure.ADC_DataAlign = ADC_DataAlign_Right;							//ADCҶ  
	ADC_InitStructure.ADC_NbrOfChannel = 1;               							//ADCͨĿΪ1
	ADC_Init(ADC1, &ADC_InitStructure);

	//ָADCתͨת
	ADC_RegularChannelConfig(ADC1, ADC_Channel_10, 1, ADC_SampleTime_55Cycles5); 
	
#ifdef USE_ADC1_DMA_PER
	ADC_DMACmd(ADC1, ENABLE);               	//ADC1 DMAʹ
#endif
	
	ADC_Cmd(ADC1, ENABLE);                   	//ADC1ʹ           													

	ADC_ResetCalibration(ADC1);              	//ADC1У׼Ĵ
  while (ADC_GetCalibrationStatus(ADC1))   	//ȴADC1У׼Ĵ
	{
	}
  ADC_StartCalibration(ADC1);              	//ADC1У׼״̬
	while(ADC_GetCalibrationStatus(ADC1))    	//ȴADC1У׼
	{
	}
		
  ADC_SoftwareStartConvCmd(ADC1, ENABLE);  	//ADC1ʽ
}

/****************************************************************
* function   	: ADC1_DMA_UserConfig()

* Description :	ADC-DMAģʼ

* input			  : 

* output      : 
*****************************************************************/
#if USE_ADC1_DMA_PER
static void ADC1_DMA_UserConfig(void)
{
	  DMA_InitTypeDef DMA_InitStructure;
	  
	  RCC_AHBPeriphClockCmd(RCC_AHBPeriph_DMA1, ENABLE); 
	  DMA_DeInit(DMA1_Channel1);                                                  //λADC1ӦDMAͨDMA1_Channel1
	   
	  DMA_InitStructure.DMA_PeripheralBaseAddr = ADC1_DR_Address;                 //ADC1תֵĴַΪַ
	  DMA_InitStructure.DMA_MemoryBaseAddr = (uint32_t)&ADCConvertedValue;        //ݴڴĻַ
    DMA_InitStructure.DMA_DIR = DMA_DIR_PeripheralSRC;                          //ΪԴ
    DMA_InitStructure.DMA_BufferSize = 1;                                       //ӵַĵĳ
    DMA_InitStructure.DMA_PeripheralInc = DMA_PeripheralInc_Disable;            //ַ
    DMA_InitStructure.DMA_MemoryInc = DMA_MemoryInc_Disable;                    //ڴַ
    DMA_InitStructure.DMA_PeripheralDataSize = DMA_PeripheralDataSize_HalfWord; //Ϊ16bit
    DMA_InitStructure.DMA_MemoryDataSize = DMA_MemoryDataSize_HalfWord;         //ڴΪ16bit
    DMA_InitStructure.DMA_Mode = DMA_Mode_Circular;                             //DMAѭģʽ
    DMA_InitStructure.DMA_Priority = DMA_Priority_High;                         //DMAȼ     
    DMA_InitStructure.DMA_M2M = DMA_M2M_Disable;                                //DMA赽ڴ洫
    DMA_Init(DMA1_Channel1, &DMA_InitStructure);                                  
	   
	  DMA_Cmd(DMA1_Channel1, ENABLE);                                             /*DMAʹ*/
}
#endif
#endif

/****************************************************************
* function   	: ARM_DELAY

* Description : ʱ

* input			  : i: 32λ

* output      : 
*****************************************************************/
void ARM_DELAY(_IO uint32_t i)
{
	for(;i>0;i--)
	{
	}
}

/***************************************end*******************************************/
